# Embedded file name: /usr/lib/enigma2/python/Components/Converter/Moon.py
from time import strftime
from Components.Converter.Converter import Converter
from Components.Element import cached
import math
import datetime
from datetime import date
from Tools.Directories import fileExists

class Moon(Converter, object):
    JULIANDAY = 0
    OSWIETLENIE = 1
    FAZA = 2
    OBRAZ = 3

    def __init__(self, type):
        Converter.__init__(self, type)
        if type == 'julianday':
            self.type = self.JULIANDAY
        elif type == 'oswietlenie':
            self.type = self.OSWIETLENIE
        elif type == 'faza':
            self.type = self.FAZA
        elif type == 'obraz':
            self.type = self.OBRAZ

    @cached
    def getDane(self):
        ksiezyc = {'mpicon': '99'}
        info = ''
        Moonpic = '99'
        R = datetime.date.today().year
        M = datetime.date.today().month
        D = datetime.date.today().day
        G = float(strftime('%H'))
        Min = float(strftime('%M'))
        S = float(strftime('%S'))
        jd = 1729279.5 + 367 * R + int(275 * M / 9) - int(7 * (4716 + R + int((M + 9) / 12)) / 4) + D + 38 - int(3 * (int((4716 + R + int((M + 9) / 12) + 83) / 100) + 1) / 4) + G / 24 + Min / 1440 + S / 86400
        K = (jd - 2451545) / 36525
        X = 297.8502042 + 445267.1115168 * K - 0.00163 * K * K + K * K * K / 545868 - K * K * K * K / 113065000
        P = 357.5291092 + 35999.0502909 * K - 0.0001536 * K * K + K * K * K / 24490000
        U = 134.9634114 + 477198.8676313 * K - 0.008997 * K * K + K * K * K / 69699 - K * K * K * K / 14712000
        F = 180 - X - 6.289 * math.sin(3.1415926535 / 180 * U) + 2.1 * math.sin(3.1415926535 / 180 * P) - 1.274 * math.sin(3.1415926535 / 180 * (2 * X - U)) - 0.658 * math.sin(3.1415926535 / 180 * (2 * X)) - 0.214 * math.sin(3.1415926535 / 180 * (2 * U)) - 0.11 * math.sin(3.1415926535 / 180 * X)
        phi1 = (1 + math.cos(3.1415926535 / 180 * F)) / 2
        K = (jd + 0.5 / 24 - 2451545) / 36525
        X = 297.8502042 + 445267.1115168 * K - 0.00163 * K * K + K * K * K / 545868 - K * K * K * K / 113065000
        P = 357.5291092 + 35999.0502909 * K - 0.0001536 * K * K + K * K * K / 24490000
        U = 134.9634114 + 477198.8676313 * K - 0.008997 * K * K + K * K * K / 69699 - K * K * K * K / 14712000
        F = 180 - X - 6.289 * math.sin(3.1415926535 / 180 * U) + 2.1 * math.sin(3.1415926535 / 180 * P) - 1.274 * math.sin(3.1415926535 / 180 * (2 * X - U)) - 0.658 * math.sin(3.1415926535 / 180 * (2 * X)) - 0.214 * math.sin(3.1415926535 / 180 * (2 * U)) - 0.11 * math.sin(3.1415926535 / 180 * X)
        phi2 = (1 + math.cos(3.1415926535 / 180 * F)) / 2
        if phi2 - phi1 < 0:
            Osw = -1
        else:
            Osw = 1
        lum = 100 * phi1
        lum1 = round(lum, 1)
        lum2 = round(lum, 3)
        b = lum1
        if b < 5 and b > 0:
            a = '5'
            u = '05'
        elif b < 10:
            a = '10'
            u = '010'
        elif b < 15:
            a = '15'
            u = '015'
        elif b < 20:
            a = '20'
            u = '020'
        elif b < 25:
            a = '25'
            u = '025'
        elif b < 30:
            a = '30'
            u = '030'
        elif b < 35:
            a = '35'
            u = '035'
        elif b < 40:
            a = '40'
            u = '040'
        elif b < 45:
            a = '45'
            u = '045'
        elif b < 50:
            a = '50'
            u = '050'
        elif b < 55 and b > 50:
            a = '55'
            u = '055'
        elif b < 60:
            a = '60'
            u = '060'
        elif b < 65:
            a = '65'
            u = '065'
        elif b < 70:
            a = '70'
            u = '070'
        elif b < 75:
            a = '75'
            u = '075'
        elif b < 80:
            a = '80'
            u = '080'
        elif b < 85:
            a = '85'
            u = '085'
        elif b < 90:
            a = '90'
            u = '090'
        elif b < 95:
            a = '95'
            u = '095'
        elif b < 100:
            a = '100'
            u = '100'
        if Osw == -1 and lum1 < 49.5 and lum1 > 0.5:
            moonPhase = '  Sierp \nubywaj\xc4\x85cy'
            Moonpic = u
        elif lum1 < 49.5 and lum1 > 0.5 and Osw == 1:
            moonPhase = '  Sierp\nprzybywaj\xc4\x85cy'
            Moonpic = a
        elif lum1 > 50.5 and lum1 < 99.5 and Osw == 1:
            moonPhase = ' Przybywaj\xc4\x85cy\n  ksi\xc4\x99\xc5\xbcyc\n  garbaty'
            Moonpic = a
        elif lum1 > 50.5 and lum1 < 99.5 and Osw == -1:
            moonPhase = ' Ubywaj\xc4\x85cy\n ksi\xc4\x99\xc5\xbcyc\n garbaty'
            Moonpic = u
        elif lum1 <= 50.5 and lum1 >= 49.5 and Osw == -1:
            moonPhase = 'III Kwadra'
            Moonpic = '050'
        elif lum1 <= 0.5:
            moonPhase = '  N\xc3\xb3w'
            Moonpic = '1'
        elif lum1 >= 99.5:
            moonPhase = ' Pe\xc5\x82nia'
            Moonpic = '100'
        elif lum1 <= 50.5 and lum1 >= 49.5 and Osw == 1:
            moonPhase = 'I Kwadra'
            Moonpic = '50'
        else:
            moonPhase = 'N/A'
            Moonpic = '99'
        ksiezyc['mpicon'] = Moonpic
        if self.type == self.JULIANDAY:
            return 'JD ' + str(jd)
        if self.type == self.OSWIETLENIE:
            return str(lum2) + ' %'
        if self.type == self.FAZA:
            return str(moonPhase)
        if self.type == self.OBRAZ:
            info = ksiezyc['mpicon']
            return info

    text = property(getDane)